var gENFSettings = {
	elementIDs: [
		"ENFEmail",
		"ENFSaveInSent",
		"ENFNotePrefix",
		"ENFNoteSuffix",
		"ENFNotebook",
		"ENFNoteTags",
		"ENFMsgTags",
		"ENFAccType",
		"ENFAlertLimit"
	],
	
	savePrefs: function() {
		for( var i = 0; i < this.elementIDs.length; i++ ) {
			var elementID = this.elementIDs[i];
			var element = document.getElementById(elementID);
			if (!element) break;
			var eltType = element.localName;
			if (eltType == "radiogroup")
			  nsPreferences.setIntPref(element.getAttribute("prefstring"), parseInt(element.value));
			else if (eltType == "checkbox")
			  nsPreferences.setBoolPref(element.getAttribute("prefstring"), element.checked);
			else if (eltType == "textbox" && element.preftype == "int")
			  nsPreferences.setIntPref(element.getAttribute("prefstring"), parseInt(element.getAttribute("value")) );
			else if (eltType == "textbox")
			  nsPreferences.setUnicharPref(element.getAttribute("prefstring"), element.value);
		  else if (eltType == "menulist" && element.getAttribute("preftype") == "string")
		  	nsPreferences.setUnicharPref(element.getAttribute("prefstring"), element.value);
			else if (eltType == "menulist")
		  	nsPreferences.setIntPref(element.getAttribute("prefstring"), parseInt(element.value));
		}
	
		return true;
	},
	
	onLoad: function() {
		try {
		for( var i = 0; i < this.elementIDs.length; i++ ) {
			var elementID = this.elementIDs[i];
			var element = document.getElementById(elementID);
			if (!element) break;
			var eltType = element.localName;
	
			if (eltType == "radiogroup") {
				var index = nsPreferences.getIntPref(element.getAttribute("prefstring")) ? nsPreferences.getIntPref(element.getAttribute("prefstring"))
																																								: element.getAttribute("defaultpref");
				element.selectedItem = element.childNodes[index];
			} else if (eltType == "checkbox") {
				element.checked = nsPreferences.getBoolPref(element.getAttribute("prefstring"), element.getAttribute("defaultpref"));
			} else if (eltType == "textbox") {
				var str = nsPreferences.copyUnicharPref(element.getAttribute("prefstring"),"");
				if (str) element.setAttribute("value", str);
			} else if (eltType == "menulist" && element.getAttribute("preftype") == "string") {
				element.value = nsPreferences.copyUnicharPref(element.getAttribute("prefstring"), element.getAttribute("defaultpref"));
			} else if (eltType == "menulist") {
				element.value = nsPreferences.getIntPref(element.getAttribute("prefstring"), element.getAttribute("defaultpref")).toString();
			}
		}
		
		this.onChangeAccountType();
		}catch(e){
			dump(e);
		}
	},
	
	onChangeAccountType: function() {
		var accType = document.getElementById("ENFAccType").getAttribute("value");
		var maxSize = accType == "premium" ? 50 : 25;
		var maxSent = accType == "premium" ? 250 : 50;
		var todaySent = this.checkLimitExpires() ? 0 : nsPreferences.getIntPref("extensions.enforward.sent_times", 0);
		
		document.getElementById("ENFNoteSize").setAttribute("value", maxSize);
		document.getElementById("ENFSentNotes").setAttribute("value", todaySent+"/"+maxSent);
		var progress = (todaySent * 100) / maxSent;
		if (progress > 100) progress = 100;
		document.getElementById("ENFSentNotesMeter").setAttribute("value", progress);
	},
	
	checkLimitExpires: function() {
		var date = new Date();
		var today = date.getFullYear() + "-" + (date.getMonth() + 1) + "-" + date.getDate();
		var last = nsPreferences.copyUnicharPref("extensions.enforward.sent_date", "");
		return today != last;
	}
};
